Hex Artifact Content

Artifact 8ff9a8d29a4cb8c40469b6fcfc4eb6b221b92ef5:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 66 32 34 33 35 33 64 30  bash..# f24353d0
0020: 32 64 39 30 66 39 37 63 37 32 62 36 39 37 37 66  2d90f97c72b6977f
0030: 33 61 38 61 30 35 30 30 36 61 64 30 36 31 32 30  3a8a05006ad06120
0040: 0a 0a 6f 75 72 53 63 72 69 70 74 3d 22 24 28 77  ..ourScript="$(w
0050: 68 69 63 68 20 22 24 30 22 29 22 0a 69 66 20 21  hich "$0")".if !
0060: 20 68 65 61 64 20 2d 33 20 22 24 7b 6f 75 72 53   head -3 "${ourS
0070: 63 72 69 70 74 7d 22 20 32 3e 2f 64 65 76 2f 6e  cript}" 2>/dev/n
0080: 75 6c 6c 20 7c 20 67 72 65 70 20 66 32 34 33 35  ull | grep f2435
0090: 33 64 30 32 64 39 30 66 39 37 63 37 32 62 36 39  3d02d90f97c72b69
00a0: 37 37 66 33 61 38 61 30 35 30 30 36 61 64 30 36  77f3a8a05006ad06
00b0: 31 32 30 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  120 >/dev/null; 
00c0: 74 68 65 6e 0a 09 65 63 68 6f 20 22 65 72 72 6f  then..echo "erro
00d0: 72 3a 20 55 6e 61 62 6c 65 20 74 6f 20 66 69 6e  r: Unable to fin
00e0: 64 20 6f 75 72 73 65 6c 76 65 73 22 20 3e 26 32  d ourselves" >&2
00f0: 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 63 64  ...exit 1.fi..cd
0100: 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24 7b 6f   "$(dirname "${o
0110: 75 72 53 63 72 69 70 74 7d 22 29 22 20 7c 7c 20  urScript}")" || 
0120: 65 78 69 74 20 31 0a 0a 70 61 74 63 68 44 69 72  exit 1..patchDir
0130: 3d 22 24 28 70 77 64 29 2f 70 61 74 63 68 65 73  ="$(pwd)/patches
0140: 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24 7b 4e 41  "..if [ -z "${NA
0150: 43 4c 5f 53 44 4b 5f 52 4f 4f 54 7d 22 20 5d 3b  CL_SDK_ROOT}" ];
0160: 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 65 72 72   then..echo "err
0170: 6f 72 3a 20 50 6c 65 61 73 65 20 73 65 74 20 4e  or: Please set N
0180: 41 43 4c 5f 53 44 4b 5f 52 4f 4f 54 20 74 6f 20  ACL_SDK_ROOT to 
0190: 74 68 65 20 70 61 74 68 20 6f 66 20 74 68 65 20  the path of the 
01a0: 63 75 72 72 65 6e 74 20 4e 61 43 6c 20 53 44 4b  current NaCl SDK
01b0: 20 74 61 72 67 65 74 22 20 3e 26 32 0a 0a 09 65   target" >&2...e
01c0: 78 69 74 20 31 0a 66 69 0a 0a 69 66 20 5b 20 21  xit 1.fi..if [ !
01d0: 20 2d 64 20 22 24 7b 4e 41 43 4c 5f 53 44 4b 5f   -d "${NACL_SDK_
01e0: 52 4f 4f 54 7d 2f 74 6f 6f 6c 63 68 61 69 6e 22  ROOT}/toolchain"
01f0: 20 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22   ]; then..echo "
0200: 65 72 72 6f 72 3a 20 49 6e 76 61 6c 69 64 20 4e  error: Invalid N
0210: 41 43 4c 5f 53 44 4b 5f 52 4f 4f 54 2c 20 6e 6f  ACL_SDK_ROOT, no
0220: 74 20 66 6f 75 6e 64 3a 20 24 7b 4e 41 43 4c 5f  t found: ${NACL_
0230: 53 44 4b 5f 52 4f 4f 54 7d 2f 74 6f 6f 6c 63 68  SDK_ROOT}/toolch
0240: 61 69 6e 22 20 3e 26 32 0a 0a 09 65 78 69 74 20  ain" >&2...exit 
0250: 31 0a 66 69 0a 0a 23 20 53 65 74 75 70 20 63 72  1.fi..# Setup cr
0260: 6f 73 73 2d 63 6f 6d 70 69 6c 65 72 20 74 6f 6f  oss-compiler too
0270: 6c 63 68 61 69 6e 0a 23 23 20 53 65 74 20 70 61  lchain.## Set pa
0280: 74 68 20 74 6f 20 69 6e 63 6c 75 64 65 20 74 68  th to include th
0290: 65 20 74 6f 6f 6c 73 0a 50 41 54 48 3d 22 24 7b  e tools.PATH="${
02a0: 50 41 54 48 7d 3a 24 7b 4e 41 43 4c 5f 53 44 4b  PATH}:${NACL_SDK
02b0: 5f 52 4f 4f 54 7d 2f 74 6f 6f 6c 63 68 61 69 6e  _ROOT}/toolchain
02c0: 2f 6c 69 6e 75 78 5f 70 6e 61 63 6c 2f 62 69 6e  /linux_pnacl/bin
02d0: 22 0a 65 78 70 6f 72 74 20 50 41 54 48 0a 0a 23  ".export PATH..#
02e0: 23 20 53 65 74 20 76 61 72 69 61 62 6c 65 73 20  # Set variables 
02f0: 6e 65 65 64 65 64 20 62 79 20 70 72 6f 6a 65 63  needed by projec
0300: 74 73 0a 48 4f 53 54 5f 43 43 3d 22 24 28 77 68  ts.HOST_CC="$(wh
0310: 69 63 68 20 22 24 7b 43 43 3a 2d 63 63 7d 22 29  ich "${CC:-cc}")
0320: 22 0a 42 55 49 4c 44 5f 43 43 3d 22 24 7b 48 4f  ".BUILD_CC="${HO
0330: 53 54 5f 43 43 7d 22 0a 43 43 5f 46 4f 52 5f 42  ST_CC}".CC_FOR_B
0340: 55 49 4c 44 3d 22 24 7b 48 4f 53 54 5f 43 43 7d  UILD="${HOST_CC}
0350: 22 0a 41 52 3d 70 6e 61 63 6c 2d 61 72 0a 41 53  ".AR=pnacl-ar.AS
0360: 3d 70 6e 61 63 6c 2d 61 73 0a 4c 44 3d 70 6e 61  =pnacl-as.LD=pna
0370: 63 6c 2d 6c 64 0a 43 43 3d 70 6e 61 63 6c 2d 63  cl-ld.CC=pnacl-c
0380: 6c 61 6e 67 0a 43 58 58 3d 70 6e 61 63 6c 2d 63  lang.CXX=pnacl-c
0390: 6c 61 6e 67 2b 2b 0a 52 41 4e 4c 49 42 3d 70 6e  lang++.RANLIB=pn
03a0: 61 63 6c 2d 72 61 6e 6c 69 62 0a 53 54 52 49 50  acl-ranlib.STRIP
03b0: 3d 70 6e 61 63 6c 2d 73 74 72 69 70 0a 4f 42 4a  =pnacl-strip.OBJ
03c0: 43 4f 50 59 3d 70 6e 61 63 6c 2d 6f 62 6a 63 6f  COPY=pnacl-objco
03d0: 70 79 0a 65 78 70 6f 72 74 20 48 4f 53 54 5f 43  py.export HOST_C
03e0: 43 20 42 55 49 4c 44 5f 43 43 20 43 43 5f 46 4f  C BUILD_CC CC_FO
03f0: 52 5f 42 55 49 4c 44 20 41 52 20 41 53 20 4c 44  R_BUILD AR AS LD
0400: 20 43 43 20 43 58 58 20 52 41 4e 4c 49 42 20 53   CC CXX RANLIB S
0410: 54 52 49 50 20 4f 42 4a 43 4f 50 59 0a 0a 23 23  TRIP OBJCOPY..##
0420: 20 53 65 74 20 73 6f 6d 65 20 43 46 4c 41 47 53   Set some CFLAGS
0430: 20 74 68 61 74 20 74 68 65 20 63 6f 6d 70 69 6c   that the compil
0440: 65 72 20 66 61 69 6c 73 20 74 6f 20 69 6e 74 65  er fails to inte
0450: 72 6e 61 6c 6c 79 20 73 65 74 0a 43 46 4c 41 47  rnally set.CFLAG
0460: 53 3d 22 2d 49 24 7b 4e 41 43 4c 5f 53 44 4b 5f  S="-I${NACL_SDK_
0470: 52 4f 4f 54 7d 2f 69 6e 63 6c 75 64 65 22 0a 43  ROOT}/include".C
0480: 58 58 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47  XXFLAGS="${CFLAG
0490: 53 7d 22 0a 43 50 50 46 4c 41 47 53 3d 22 24 7b  S}".CPPFLAGS="${
04a0: 43 46 4c 41 47 53 7d 22 0a 65 78 70 6f 72 74 20  CFLAGS}".export 
04b0: 43 46 4c 41 47 53 20 43 58 58 46 4c 41 47 53 20  CFLAGS CXXFLAGS 
04c0: 43 50 50 46 4c 41 47 53 0a 0a 23 20 46 75 6e 63  CPPFLAGS..# Func
04d0: 74 69 6f 6e 20 74 6f 20 64 6f 77 6e 6c 6f 61 64  tion to download
04e0: 20 66 69 6c 65 73 20 66 72 6f 6d 20 74 68 65 20   files from the 
04f0: 69 6e 74 65 72 77 65 62 73 20 61 6e 64 20 76 65  interwebs and ve
0500: 72 69 66 79 20 74 68 65 6d 0a 66 75 6e 63 74 69  rify them.functi
0510: 6f 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a  on download() {.
0520: 09 6c 6f 63 61 6c 20 75 72 6c 20 66 69 6c 65 20  .local url file 
0530: 68 61 73 68 0a 09 6c 6f 63 61 6c 20 68 61 73 68  hash..local hash
0540: 4d 65 74 68 6f 64 0a 09 6c 6f 63 61 6c 20 63 68  Method..local ch
0550: 6b 48 61 73 68 0a 0a 09 75 72 6c 3d 22 24 31 22  kHash...url="$1"
0560: 0a 09 66 69 6c 65 3d 22 24 32 22 0a 09 68 61 73  ..file="$2"..has
0570: 68 3d 22 24 33 22 0a 0a 09 69 66 20 5b 20 2d 66  h="$3"...if [ -f
0580: 20 22 24 7b 66 69 6c 65 7d 22 20 5d 3b 20 74 68   "${file}" ]; th
0590: 65 6e 0a 09 09 72 65 74 75 72 6e 20 30 0a 09 66  en...return 0..f
05a0: 69 0a 0a 09 6d 6b 64 69 72 20 2d 70 20 22 24 28  i...mkdir -p "$(
05b0: 64 69 72 6e 61 6d 65 20 22 24 7b 66 69 6c 65 7d  dirname "${file}
05c0: 22 29 22 0a 0a 09 68 61 73 68 4d 65 74 68 6f 64  ")"...hashMethod
05d0: 3d 27 73 68 61 32 35 36 27 0a 0a 09 72 6d 20 2d  ='sha256'...rm -
05e0: 66 20 22 24 7b 66 69 6c 65 7d 2e 6e 65 77 22 0a  f "${file}.new".
05f0: 09 77 67 65 74 20 2d 2d 68 65 61 64 65 72 20 22  .wget --header "
0600: 58 2d 43 61 63 68 65 2d 55 52 4c 3a 20 24 7b 75  X-Cache-URL: ${u
0610: 72 6c 7d 22 20 2d 4f 20 22 24 7b 66 69 6c 65 7d  rl}" -O "${file}
0620: 2e 6e 65 77 22 20 22 68 74 74 70 3a 2f 2f 68 61  .new" "http://ha
0630: 73 68 63 61 63 68 65 2e 72 6b 65 65 6e 65 2e 6f  shcache.rkeene.o
0640: 72 67 2f 24 7b 68 61 73 68 4d 65 74 68 6f 64 7d  rg/${hashMethod}
0650: 2f 24 7b 68 61 73 68 7d 22 20 7c 7c 20 5c 0a 09  /${hash}" || \..
0660: 09 77 67 65 74 20 2d 4f 20 22 24 7b 66 69 6c 65  .wget -O "${file
0670: 7d 2e 6e 65 77 22 20 22 24 7b 75 72 6c 7d 22 20  }.new" "${url}" 
0680: 7c 7c 20 5c 0a 09 09 72 65 74 75 72 6e 20 31 0a  || \...return 1.
0690: 0a 09 63 68 6b 48 61 73 68 3d 22 24 28 6f 70 65  ..chkHash="$(ope
06a0: 6e 73 73 6c 20 22 24 7b 68 61 73 68 4d 65 74 68  nssl "${hashMeth
06b0: 6f 64 7d 22 20 22 24 7b 66 69 6c 65 7d 2e 6e 65  od}" "${file}.ne
06c0: 77 22 20 7c 20 73 65 64 20 27 73 40 2e 2a 3d 20  w" | sed 's@.*= 
06d0: 2a 40 40 27 29 22 0a 0a 09 69 66 20 5b 20 22 24  *@@')"...if [ "$
06e0: 7b 63 68 6b 48 61 73 68 7d 22 20 21 3d 20 22 24  {chkHash}" != "$
06f0: 7b 68 61 73 68 7d 22 20 5d 3b 20 74 68 65 6e 0a  {hash}" ]; then.
0700: 09 09 65 63 68 6f 20 22 65 72 72 6f 72 3a 20 43  ..echo "error: C
0710: 68 65 63 6b 73 75 6d 20 6d 69 73 6d 61 74 63 68  hecksum mismatch
0720: 3a 20 47 6f 74 3a 20 24 7b 63 68 6b 48 61 73 68  : Got: ${chkHash
0730: 7d 3b 20 45 78 70 65 63 74 65 64 3a 20 24 7b 68  }; Expected: ${h
0740: 61 73 68 7d 22 20 3e 26 32 0a 0a 09 09 72 65 74  ash}" >&2....ret
0750: 75 72 6e 20 31 0a 09 66 69 0a 0a 09 6d 76 20 22  urn 1..fi...mv "
0760: 24 7b 66 69 6c 65 7d 2e 6e 65 77 22 20 22 24 7b  ${file}.new" "${
0770: 66 69 6c 65 7d 22 0a 0a 09 72 65 74 75 72 6e 20  file}"...return 
0780: 30 0a 7d 0a 0a 23 20 45 78 74 72 61 63 74 20 61  0.}..# Extract a
0790: 6e 20 61 72 63 68 69 76 65 20 69 6e 74 6f 20 61  n archive into a
07a0: 20 64 69 72 65 63 74 6f 72 79 2c 20 73 74 72 69   directory, stri
07b0: 70 70 69 6e 67 20 74 68 65 20 74 6f 70 2d 6c 65  pping the top-le
07c0: 76 65 6c 20 64 69 72 65 63 74 6f 72 79 0a 23 20  vel directory.# 
07d0: 69 66 20 74 68 61 74 20 69 73 20 61 6c 6c 20 74  if that is all t
07e0: 68 61 74 20 69 74 20 63 6f 6e 74 61 69 6e 73 0a  hat it contains.
07f0: 66 75 6e 63 74 69 6f 6e 20 65 78 74 72 61 63 74  function extract
0800: 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 66 69 6c 65  () {..local file
0810: 20 64 69 72 65 63 74 6f 72 79 0a 0a 09 66 69 6c   directory...fil
0820: 65 3d 22 24 31 22 0a 09 64 69 72 65 63 74 6f 72  e="$1"..director
0830: 79 3d 22 24 32 22 0a 0a 09 69 66 20 5b 20 21 20  y="$2"...if [ ! 
0840: 2d 66 20 22 24 7b 66 69 6c 65 7d 22 20 5d 3b 20  -f "${file}" ]; 
0850: 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 65 72 72  then...echo "err
0860: 6f 72 3a 20 55 6e 61 62 6c 65 20 74 6f 20 65 78  or: Unable to ex
0870: 74 72 61 63 74 20 5c 22 24 7b 66 69 6c 65 7d 5c  tract \"${file}\
0880: 22 22 20 3e 26 32 0a 0a 09 09 72 65 74 75 72 6e  "" >&2....return
0890: 20 31 0a 09 66 69 0a 0a 09 72 6d 20 2d 72 66 20   1..fi...rm -rf 
08a0: 22 24 7b 64 69 72 65 63 74 6f 72 79 7d 22 0a 0a  "${directory}"..
08b0: 09 6d 6b 64 69 72 20 2d 70 20 22 24 7b 64 69 72  .mkdir -p "${dir
08c0: 65 63 74 6f 72 79 7d 22 20 7c 7c 20 72 65 74 75  ectory}" || retu
08d0: 72 6e 20 31 0a 09 28 0a 09 09 63 64 20 22 24 7b  rn 1..(...cd "${
08e0: 64 69 72 65 63 74 6f 72 79 7d 22 20 7c 7c 20 65  directory}" || e
08f0: 78 69 74 20 31 0a 0a 09 09 63 61 73 65 20 22 24  xit 1....case "$
0900: 7b 66 69 6c 65 7d 22 20 69 6e 0a 09 09 09 2a 2e  {file}" in....*.
0910: 74 61 72 2e 62 7a 32 7c 2a 2e 62 7a 32 29 0a 09  tar.bz2|*.bz2)..
0920: 09 09 09 62 7a 69 70 32 20 2d 64 63 20 7c 20 74  ...bzip2 -dc | t
0930: 61 72 20 2d 78 66 20 2d 20 7c 7c 20 65 78 69 74  ar -xf - || exit
0940: 20 31 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2e 74   1.....;;....*.t
0950: 61 72 2e 67 7a 7c 2a 2e 74 67 7a 29 0a 09 09 09  ar.gz|*.tgz)....
0960: 09 67 7a 69 70 20 2d 64 63 20 7c 20 74 61 72 20  .gzip -dc | tar 
0970: 2d 78 66 20 2d 20 7c 7c 20 65 78 69 74 20 31 0a  -xf - || exit 1.
0980: 09 09 09 09 3b 3b 0a 09 09 09 2a 2e 74 61 72 2e  ....;;....*.tar.
0990: 78 7a 7c 2a 2e 74 78 7a 29 0a 09 09 09 09 78 7a  xz|*.txz).....xz
09a0: 20 2d 64 63 20 7c 20 74 61 72 20 2d 78 66 20 2d   -dc | tar -xf -
09b0: 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 09 09 3b   || exit 1.....;
09c0: 3b 0a 09 09 09 2a 2e 7a 69 70 29 0a 09 09 09 09  ;....*.zip).....
09d0: 63 61 74 20 3e 20 78 2e 7a 69 70 20 7c 7c 20 65  cat > x.zip || e
09e0: 78 69 74 20 31 0a 09 09 09 09 75 6e 7a 69 70 20  xit 1.....unzip 
09f0: 78 2e 7a 69 70 20 7c 7c 20 65 78 69 74 20 31 0a  x.zip || exit 1.
0a00: 09 09 09 09 72 6d 20 2d 66 20 78 2e 7a 69 70 0a  ....rm -f x.zip.
0a10: 09 09 09 09 3b 3b 0a 09 09 09 2a 29 0a 09 09 09  ....;;....*)....
0a20: 09 65 63 68 6f 20 22 65 72 72 6f 72 3a 20 44 6f  .echo "error: Do
0a30: 6e 27 74 20 6b 6e 6f 77 20 77 68 61 74 20 74 6f  n't know what to
0a40: 20 64 6f 20 77 69 74 68 20 5c 22 24 7b 66 69 6c   do with \"${fil
0a50: 65 7d 5c 22 22 20 3e 26 32 0a 0a 09 09 09 09 65  e}\"" >&2......e
0a60: 78 69 74 20 31 0a 09 09 09 09 3b 3b 0a 09 09 65  xit 1.....;;...e
0a70: 73 61 63 0a 0a 09 09 69 66 20 5b 20 2d 64 20 22  sac....if [ -d "
0a80: 24 28 65 63 68 6f 20 2a 29 22 20 5d 3b 20 74 68  $(echo *)" ]; th
0a90: 65 6e 0a 09 09 09 6d 76 20 2a 2f 2a 20 2e 20 3e  en....mv */* . >
0aa0: 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76  /dev/null 2>/dev
0ab0: 2f 6e 75 6c 6c 0a 09 09 66 69 0a 09 29 20 3c 20  /null...fi..) < 
0ac0: 22 24 7b 66 69 6c 65 7d 22 20 7c 7c 20 72 65 74  "${file}" || ret
0ad0: 75 72 6e 20 31 0a 0a 09 72 65 74 75 72 6e 20 30  urn 1...return 0
0ae0: 0a 7d 0a 0a 23 20 55 73 65 72 2d 6f 76 65 72 72  .}..# User-overr
0af0: 69 64 61 62 6c 65 20 22 6d 61 6b 65 22 0a 66 75  idable "make".fu
0b00: 6e 63 74 69 6f 6e 20 6d 61 6b 65 28 29 20 7b 0a  nction make() {.
0b10: 09 22 24 7b 4d 41 4b 45 3a 2d 24 28 77 68 69 63  ."${MAKE:-$(whic
0b20: 68 20 6d 61 6b 65 29 7d 22 20 22 24 40 22 0a 7d  h make)}" "$@".}
0b30: 0a 0a 23 20 42 75 69 6c 64 20 22 7a 6c 69 62 22  ..# Build "zlib"
0b40: 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64 5a  .function buildZ
0b50: 6c 69 62 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 76  lib() {..local v
0b60: 65 72 73 69 6f 6e 20 75 72 6c 20 70 6b 67 20 73  ersion url pkg s
0b70: 68 61 32 35 36 20 63 6f 6e 66 69 67 75 72 65 5f  ha256 configure_
0b80: 65 78 74 72 61 0a 09 6c 6f 63 61 6c 20 61 72 63  extra..local arc
0b90: 68 69 76 65 20 77 6f 72 6b 64 69 72 0a 0a 09 70  hive workdir...p
0ba0: 6b 67 3d 27 7a 6c 69 62 27 0a 09 76 65 72 73 69  kg='zlib'..versi
0bb0: 6f 6e 3d 27 31 2e 32 2e 38 27 0a 09 75 72 6c 3d  on='1.2.8'..url=
0bc0: 22 68 74 74 70 3a 2f 2f 7a 6c 69 62 2e 6e 65 74  "http://zlib.net
0bd0: 2f 7a 6c 69 62 2d 24 7b 76 65 72 73 69 6f 6e 7d  /zlib-${version}
0be0: 2e 74 61 72 2e 67 7a 22 0a 09 73 68 61 32 35 36  .tar.gz"..sha256
0bf0: 3d 27 33 36 36 35 38 63 62 37 36 38 61 35 34 63  ='36658cb768a54c
0c00: 31 64 34 64 65 63 34 33 63 33 31 31 36 63 32 37  1d4dec43c3116c27
0c10: 65 64 38 39 33 65 38 38 62 30 32 65 63 66 63 62  ed893e88b02ecfcb
0c20: 34 34 66 32 31 36 36 66 39 63 30 62 37 66 32 61  44f2166f9c0b7f2a
0c30: 30 64 27 0a 0a 09 61 72 63 68 69 76 65 3d 22 61  0d'...archive="a
0c40: 72 63 68 69 76 65 2f 24 7b 70 6b 67 7d 2d 24 7b  rchive/${pkg}-${
0c50: 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e 67 7a 22  version}.tar.gz"
0c60: 0a 09 77 6f 72 6b 64 69 72 3d 22 77 6f 72 6b 64  ..workdir="workd
0c70: 69 72 2d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41  ir-${RANDOM}${RA
0c80: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
0c90: 52 41 4e 44 4f 4d 7d 2e 62 75 69 6c 64 22 0a 0a  RANDOM}.build"..
0ca0: 09 64 6f 77 6e 6c 6f 61 64 20 22 24 7b 75 72 6c  .download "${url
0cb0: 7d 22 20 22 24 7b 61 72 63 68 69 76 65 7d 22 20  }" "${archive}" 
0cc0: 22 24 7b 73 68 61 32 35 36 7d 22 20 7c 7c 20 72  "${sha256}" || r
0cd0: 65 74 75 72 6e 20 31 0a 09 65 78 74 72 61 63 74  eturn 1..extract
0ce0: 20 22 24 7b 61 72 63 68 69 76 65 7d 22 20 22 24   "${archive}" "$
0cf0: 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 72 65  {workdir}" || re
0d00: 74 75 72 6e 20 31 0a 0a 09 28 0a 09 09 63 64 20  turn 1...(...cd 
0d10: 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20  "${workdir}" || 
0d20: 65 78 69 74 20 31 0a 0a 09 09 2e 2f 63 6f 6e 66  exit 1...../conf
0d30: 69 67 75 72 65 20 2d 2d 70 72 65 66 69 78 3d 2f  igure --prefix=/
0d40: 20 2d 2d 6c 69 62 64 69 72 3d 2f 6c 69 62 20 2d   --libdir=/lib -
0d50: 2d 73 74 61 74 69 63 20 7c 7c 20 65 78 69 74 20  -static || exit 
0d60: 31 0a 09 09 6d 61 6b 65 20 7c 7c 20 65 78 69 74  1...make || exit
0d70: 20 31 0a 09 09 6d 61 6b 65 20 44 45 53 54 44 49   1...make DESTDI
0d80: 52 3d 22 24 7b 69 6e 73 74 64 69 72 7d 22 20 69  R="${instdir}" i
0d90: 6e 73 74 61 6c 6c 20 7c 7c 20 65 78 69 74 20 31  nstall || exit 1
0da0: 0a 09 29 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a  ..) || return 1.
0db0: 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77 6f 72 6b  ..rm -rf "${work
0dc0: 64 69 72 7d 22 0a 0a 09 72 65 74 75 72 6e 20 30  dir}"...return 0
0dd0: 0a 7d 0a 0a 23 20 42 75 69 6c 64 20 22 62 6f 6f  .}..# Build "boo
0de0: 73 74 22 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69  st".function bui
0df0: 6c 64 42 6f 6f 73 74 28 29 20 7b 0a 09 6c 6f 63  ldBoost() {..loc
0e00: 61 6c 20 76 65 72 73 69 6f 6e 20 75 72 6c 20 70  al version url p
0e10: 6b 67 20 73 68 61 32 35 36 20 63 6f 6e 66 69 67  kg sha256 config
0e20: 75 72 65 5f 65 78 74 72 61 0a 09 6c 6f 63 61 6c  ure_extra..local
0e30: 20 61 72 63 68 69 76 65 20 77 6f 72 6b 64 69 72   archive workdir
0e40: 0a 0a 09 70 6b 67 3d 27 62 6f 6f 73 74 27 0a 09  ...pkg='boost'..
0e50: 76 65 72 73 69 6f 6e 3d 27 31 2e 35 37 2e 30 27  version='1.57.0'
0e60: 0a 09 75 72 6c 3d 22 68 74 74 70 3a 2f 2f 64 6f  ..url="http://do
0e70: 77 6e 6c 6f 61 64 73 2e 73 6f 75 72 63 65 66 6f  wnloads.sourcefo
0e80: 72 67 65 2e 6e 65 74 2f 70 72 6f 6a 65 63 74 2f  rge.net/project/
0e90: 62 6f 6f 73 74 2f 62 6f 6f 73 74 2f 24 7b 76 65  boost/boost/${ve
0ea0: 72 73 69 6f 6e 7d 2f 62 6f 6f 73 74 5f 60 65 63  rsion}/boost_`ec
0eb0: 68 6f 20 24 7b 76 65 72 73 69 6f 6e 7d 20 7c 20  ho ${version} | 
0ec0: 73 65 64 20 27 73 5f 5c 2e 5f 5c 5f 5f 67 27 60  sed 's_\._\__g'`
0ed0: 2e 74 61 72 2e 62 7a 32 22 0a 09 73 68 61 32 35  .tar.bz2"..sha25
0ee0: 36 3d 27 39 31 30 63 38 63 30 32 32 61 33 33 63  6='910c8c022a33c
0ef0: 63 65 63 37 66 30 38 38 62 64 36 35 64 34 66 31  cec7f088bd65d4f1
0f00: 34 62 34 36 36 35 38 38 64 64 61 39 34 62 61 32  4b466588dda94ba2
0f10: 31 32 34 65 37 38 62 38 63 35 37 64 62 32 36 34  124e78b8c57db264
0f20: 39 36 37 27 0a 0a 09 61 72 63 68 69 76 65 3d 22  967'...archive="
0f30: 61 72 63 68 69 76 65 2f 24 7b 70 6b 67 7d 2d 24  archive/${pkg}-$
0f40: 7b 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e 62 7a  {version}.tar.bz
0f50: 32 22 0a 09 77 6f 72 6b 64 69 72 3d 22 77 6f 72  2"..workdir="wor
0f60: 6b 64 69 72 2d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  kdir-${RANDOM}${
0f70: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
0f80: 24 7b 52 41 4e 44 4f 4d 7d 2e 62 75 69 6c 64 22  ${RANDOM}.build"
0f90: 0a 0a 09 64 6f 77 6e 6c 6f 61 64 20 22 24 7b 75  ...download "${u
0fa0: 72 6c 7d 22 20 22 24 7b 61 72 63 68 69 76 65 7d  rl}" "${archive}
0fb0: 22 20 22 24 7b 73 68 61 32 35 36 7d 22 20 7c 7c  " "${sha256}" ||
0fc0: 20 72 65 74 75 72 6e 20 31 0a 09 65 78 74 72 61   return 1..extra
0fd0: 63 74 20 22 24 7b 61 72 63 68 69 76 65 7d 22 20  ct "${archive}" 
0fe0: 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20  "${workdir}" || 
0ff0: 72 65 74 75 72 6e 20 31 0a 0a 09 28 0a 09 09 63  return 1...(...c
1000: 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c  d "${workdir}" |
1010: 7c 20 65 78 69 74 20 31 0a 0a 09 09 2e 2f 62 6f  | exit 1...../bo
1020: 6f 74 73 74 72 61 70 2e 73 68 20 2d 2d 70 72 65  otstrap.sh --pre
1030: 66 69 78 3d 22 24 7b 69 6e 73 74 64 69 72 7d 22  fix="${instdir}"
1040: 20 2d 2d 77 69 74 68 2d 70 79 74 68 6f 6e 3d 66   --with-python=f
1050: 61 6c 73 65 20 2d 2d 73 68 6f 77 2d 6c 69 62 72  alse --show-libr
1060: 61 72 69 65 73 0a 0a 09 09 2e 2f 62 6f 6f 74 73  aries...../boots
1070: 74 72 61 70 2e 73 68 20 2d 2d 70 72 65 66 69 78  trap.sh --prefix
1080: 3d 22 24 7b 69 6e 73 74 64 69 72 7d 22 20 2d 2d  ="${instdir}" --
1090: 77 69 74 68 2d 70 79 74 68 6f 6e 3d 66 61 6c 73  with-python=fals
10a0: 65 20 2d 2d 77 69 74 68 6f 75 74 2d 6c 69 62 72  e --without-libr
10b0: 61 72 69 65 73 3d 27 61 74 6f 6d 69 63 2c 63 68  aries='atomic,ch
10c0: 72 6f 6e 6f 2c 63 6f 6e 74 61 69 6e 65 72 2c 63  rono,container,c
10d0: 6f 6e 74 65 78 74 2c 63 6f 72 6f 75 74 69 6e 65  ontext,coroutine
10e0: 2c 64 61 74 65 5f 74 69 6d 65 2c 65 78 63 65 70  ,date_time,excep
10f0: 74 69 6f 6e 2c 66 69 6c 65 73 79 73 74 65 6d 2c  tion,filesystem,
1100: 67 72 61 70 68 2c 67 72 61 70 68 5f 70 61 72 61  graph,graph_para
1110: 6c 6c 65 6c 2c 69 6f 73 74 72 65 61 6d 73 2c 6c  llel,iostreams,l
1120: 6f 63 61 6c 65 2c 6c 6f 67 2c 6d 61 74 68 2c 6d  ocale,log,math,m
1130: 70 69 2c 70 72 6f 67 72 61 6d 5f 6f 70 74 69 6f  pi,program_optio
1140: 6e 73 2c 70 79 74 68 6f 6e 2c 72 61 6e 64 6f 6d  ns,python,random
1150: 2c 72 65 67 65 78 2c 73 65 72 69 61 6c 69 7a 61  ,regex,serializa
1160: 74 69 6f 6e 2c 73 69 67 6e 61 6c 73 2c 73 79 73  tion,signals,sys
1170: 74 65 6d 2c 74 65 73 74 2c 74 68 72 65 61 64 2c  tem,test,thread,
1180: 74 69 6d 65 72 2c 77 61 76 65 27 20 7c 7c 20 65  timer,wave' || e
1190: 78 69 74 20 31 0a 0a 09 09 65 63 68 6f 20 22 75  xit 1....echo "u
11a0: 73 69 6e 67 20 67 63 63 20 3a 20 70 6e 61 63 6c  sing gcc : pnacl
11b0: 20 3a 20 24 7b 43 58 58 7d 20 3b 22 20 3e 3e 20   : ${CXX} ;" >> 
11c0: 70 72 6f 6a 65 63 74 2d 63 6f 6e 66 69 67 2e 6a  project-config.j
11d0: 61 6d 0a 0a 09 09 2e 2f 62 32 20 2d 2d 64 65 62  am...../b2 --deb
11e0: 75 67 2d 63 6f 6e 66 69 67 75 72 61 74 69 6f 6e  ug-configuration
11f0: 20 74 6f 6f 6c 73 65 74 3d 67 63 63 2d 70 6e 61   toolset=gcc-pna
1200: 63 6c 20 74 61 72 67 65 74 2d 6f 73 3d 6c 69 6e  cl target-os=lin
1210: 75 78 20 6c 69 6e 6b 3d 73 74 61 74 69 63 20 72  ux link=static r
1220: 75 6e 74 69 6d 65 2d 6c 69 6e 6b 3d 73 74 61 74  untime-link=stat
1230: 69 63 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09  ic || exit 1....
1240: 2e 2f 62 6a 61 6d 20 69 6e 73 74 61 6c 6c 20 7c  ./bjam install |
1250: 20 67 72 65 70 20 2d 76 20 27 5e 63 6f 6d 6d 6f   grep -v '^commo
1260: 6e 2e 63 6f 70 79 20 27 0a 0a 09 09 65 78 69 74  n.copy '....exit
1270: 20 30 0a 09 29 20 7c 7c 20 72 65 74 75 72 6e 20   0..) || return 
1280: 31 0a 0a 09 72 6d 20 2d 72 66 20 22 24 7b 77 6f  1...rm -rf "${wo
1290: 72 6b 64 69 72 7d 22 0a 0a 09 72 65 74 75 72 6e  rkdir}"...return
12a0: 20 30 0a 7d 0a 0a 23 20 42 75 69 6c 64 20 74 68   0.}..# Build th
12b0: 65 20 6c 69 62 70 63 73 63 20 77 65 20 6e 65 65  e libpcsc we nee
12c0: 64 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64  d.function build
12d0: 50 43 53 43 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  PCSC() {..local 
12e0: 76 65 72 73 69 6f 6e 20 75 72 6c 20 70 6b 67 20  version url pkg 
12f0: 73 68 61 32 35 36 20 63 6f 6e 66 69 67 75 72 65  sha256 configure
1300: 5f 65 78 74 72 61 0a 09 6c 6f 63 61 6c 20 61 72  _extra..local ar
1310: 63 68 69 76 65 20 77 6f 72 6b 64 69 72 0a 0a 09  chive workdir...
1320: 62 75 69 6c 64 42 6f 6f 73 74 20 7c 7c 20 72 65  buildBoost || re
1330: 74 75 72 6e 20 31 0a 0a 09 70 6b 67 3d 27 73 6d  turn 1...pkg='sm
1340: 61 72 74 2d 63 61 72 64 2d 63 6c 69 65 6e 74 2d  art-card-client-
1350: 63 2d 65 78 61 6d 70 6c 65 2d 61 70 70 2d 73 6f  c-example-app-so
1360: 75 72 63 65 73 27 0a 09 76 65 72 73 69 6f 6e 3d  urces'..version=
1370: 27 30 2e 30 2e 30 27 0a 09 73 68 61 32 35 36 3d  '0.0.0'..sha256=
1380: 27 36 38 39 37 30 63 36 64 63 34 62 35 35 64 32  '68970c6dc4b55d2
1390: 34 61 34 35 33 62 63 66 65 35 37 36 38 61 66 32  4a453bcfe5768af2
13a0: 62 38 37 37 66 35 35 33 61 39 32 61 33 39 30 62  b877f553a92a390b
13b0: 65 37 66 39 33 35 64 62 36 32 32 33 64 34 62 63  e7f935db6223d4bc
13c0: 35 27 0a 0a 09 61 72 63 68 69 76 65 3d 22 61 72  5'...archive="ar
13d0: 63 68 69 76 65 2f 24 7b 70 6b 67 7d 2e 7a 69 70  chive/${pkg}.zip
13e0: 22 0a 09 77 6f 72 6b 64 69 72 3d 22 77 6f 72 6b  "..workdir="work
13f0: 64 69 72 2d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52  dir-${RANDOM}${R
1400: 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24  ANDOM}${RANDOM}$
1410: 7b 52 41 4e 44 4f 4d 7d 2e 62 75 69 6c 64 22 0a  {RANDOM}.build".
1420: 0a 09 65 78 74 72 61 63 74 20 22 24 7b 61 72 63  ..extract "${arc
1430: 68 69 76 65 7d 22 20 22 24 7b 77 6f 72 6b 64 69  hive}" "${workdi
1440: 72 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a  r}" || return 1.
1450: 0a 09 28 0a 09 09 63 64 20 22 24 7b 77 6f 72 6b  ..(...cd "${work
1460: 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  dir}" || exit 1.
1470: 0a 09 09 23 20 43 6f 70 79 20 6f 75 74 20 50 43  ...# Copy out PC
1480: 2f 53 43 20 68 65 61 64 65 72 73 20 66 6f 72 20  /SC headers for 
1490: 6c 61 74 65 72 20 75 73 65 0a 09 09 6d 6b 64 69  later use...mkdi
14a0: 72 20 2d 70 20 22 24 7b 69 6e 73 74 64 69 72 7d  r -p "${instdir}
14b0: 2f 69 6e 63 6c 75 64 65 2f 50 43 53 43 22 20 7c  /include/PCSC" |
14c0: 7c 20 65 78 69 74 20 31 0a 09 09 63 70 20 74 68  | exit 1...cp th
14d0: 69 72 64 5f 70 61 72 74 79 2f 70 63 73 63 2d 6c  ird_party/pcsc-l
14e0: 69 74 65 2f 73 72 63 2f 73 72 63 2f 50 43 53 43  ite/src/src/PCSC
14f0: 2f 2a 2e 68 20 22 24 7b 69 6e 73 74 64 69 72 7d  /*.h "${instdir}
1500: 2f 69 6e 63 6c 75 64 65 2f 50 43 53 43 22 20 7c  /include/PCSC" |
1510: 7c 20 65 78 69 74 20 31 0a 0a 09 09 23 20 43 6f  | exit 1....# Co
1520: 70 79 20 6f 75 74 20 65 78 74 72 61 20 68 65 61  py out extra hea
1530: 64 65 72 73 0a 09 09 63 61 74 20 3c 3c 20 5c 5f  ders...cat << \_
1540: 45 4f 46 5f 20 3e 20 22 24 7b 69 6e 73 74 64 69  EOF_ > "${instdi
1550: 72 7d 2f 69 6e 63 6c 75 64 65 2f 50 43 53 43 2f  r}/include/PCSC/
1560: 70 63 73 63 2d 6e 61 63 6c 2e 68 22 0a 23 69 66  pcsc-nacl.h".#if
1570: 6e 64 65 66 20 50 43 53 43 5f 4e 41 43 4c 5f 48  ndef PCSC_NACL_H
1580: 0a 23 64 65 66 69 6e 65 20 50 43 53 43 5f 4e 41  .#define PCSC_NA
1590: 43 4c 5f 48 20 31 0a 23 69 66 64 65 66 20 5f 5f  CL_H 1.#ifdef __
15a0: 63 70 6c 75 73 70 6c 75 73 0a 23 69 6e 63 6c 75  cplusplus.#inclu
15b0: 64 65 20 3c 70 70 61 70 69 2f 63 70 70 2f 63 6f  de <ppapi/cpp/co
15c0: 72 65 2e 68 3e 0a 23 69 6e 63 6c 75 64 65 20 3c  re.h>.#include <
15d0: 70 70 61 70 69 2f 63 70 70 2f 69 6e 73 74 61 6e  ppapi/cpp/instan
15e0: 63 65 2e 68 3e 0a 0a 76 6f 69 64 20 70 63 73 63  ce.h>..void pcsc
15f0: 4e 61 43 6c 49 6e 69 74 28 70 70 3a 3a 49 6e 73  NaClInit(pp::Ins
1600: 74 61 6e 63 65 20 2a 69 6e 73 74 61 6e 63 65 2c  tance *instance,
1610: 20 70 70 3a 3a 43 6f 72 65 20 2a 63 6f 72 65 29   pp::Core *core)
1620: 3b 0a 23 65 6e 64 69 66 0a 23 65 6e 64 69 66 0a  ;.#endif.#endif.
1630: 5f 45 4f 46 5f 0a 0a 09 09 23 20 43 6f 70 79 20  _EOF_....# Copy 
1640: 6f 75 74 20 4a 61 76 61 53 63 72 69 70 74 20 66  out JavaScript f
1650: 69 6c 65 73 20 66 6f 72 20 6c 61 74 65 72 20 75  iles for later u
1660: 73 65 0a 09 09 6d 6b 64 69 72 20 22 24 7b 69 6e  se...mkdir "${in
1670: 73 74 64 69 72 7d 2f 6a 73 22 20 7c 7c 20 65 78  stdir}/js" || ex
1680: 69 74 20 31 0a 09 09 63 70 20 63 6f 6d 6d 6f 6e  it 1...cp common
1690: 2d 75 74 69 6c 73 2f 2a 2e 6a 73 20 22 24 7b 69  -utils/*.js "${i
16a0: 6e 73 74 64 69 72 7d 2f 6a 73 22 20 7c 7c 20 65  nstdir}/js" || e
16b0: 78 69 74 20 31 0a 09 09 63 70 20 74 68 69 72 64  xit 1...cp third
16c0: 5f 70 61 72 74 79 2f 70 63 73 63 2d 6c 69 74 65  _party/pcsc-lite
16d0: 2f 63 6c 69 65 6e 74 2d 73 69 64 65 2f 2a 2e 6a  /client-side/*.j
16e0: 73 20 22 24 7b 69 6e 73 74 64 69 72 7d 2f 6a 73  s "${instdir}/js
16f0: 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 23  " || exit 1....#
1700: 20 42 75 69 6c 64 20 6c 69 62 70 63 73 63 0a 09   Build libpcsc..
1710: 09 23 23 20 41 73 73 65 6d 62 6c 65 20 61 6c 6c  .## Assemble all
1720: 20 74 68 65 20 66 69 6c 65 73 20 69 6e 74 6f 20   the files into 
1730: 61 20 73 69 6e 67 6c 65 20 74 72 65 65 0a 09 09  a single tree...
1740: 66 6f 72 20 66 69 6c 65 20 69 6e 20 6c 6f 67 67  for file in logg
1750: 69 6e 67 2e 68 20 73 63 61 72 64 5f 73 74 72 75  ing.h scard_stru
1760: 63 74 73 5f 73 65 72 69 61 6c 69 7a 61 74 69 6f  cts_serializatio
1770: 6e 2e 68 20 64 6f 6d 5f 72 65 71 75 65 73 74 73  n.h dom_requests
1780: 5f 6d 61 6e 61 67 65 72 2e 68 20 74 68 72 65 61  _manager.h threa
1790: 64 5f 73 61 66 65 5f 73 74 72 69 6e 67 5f 70 6f  d_safe_string_po
17a0: 6f 6c 2e 68 20 5c 0a 09 09 20 20 20 20 70 70 5f  ol.h \...    pp_
17b0: 76 61 72 5f 75 74 69 6c 73 2e 63 63 20 70 70 5f  var_utils.cc pp_
17c0: 76 61 72 5f 75 74 69 6c 73 2e 68 20 73 63 61 72  var_utils.h scar
17d0: 64 5f 73 74 72 75 63 74 73 5f 73 65 72 69 61 6c  d_structs_serial
17e0: 69 7a 61 74 69 6f 6e 2e 63 63 20 64 6f 6d 5f 72  ization.cc dom_r
17f0: 65 71 75 65 73 74 73 5f 6d 61 6e 61 67 65 72 2e  equests_manager.
1800: 63 63 20 6c 6f 67 67 69 6e 67 2e 63 63 3b 20 64  cc logging.cc; d
1810: 6f 0a 09 09 09 66 69 6e 64 20 2e 20 2d 74 79 70  o....find . -typ
1820: 65 20 66 20 2d 6e 61 6d 65 20 22 24 7b 66 69 6c  e f -name "${fil
1830: 65 7d 22 20 2d 65 78 65 63 20 63 70 20 27 7b 7d  e}" -exec cp '{}
1840: 27 20 74 68 69 72 64 5f 70 61 72 74 79 2f 70 63  ' third_party/pc
1850: 73 63 2d 6c 69 74 65 2f 63 6c 69 65 6e 74 2d 73  sc-lite/client-s
1860: 69 64 65 2f 20 27 3b 27 0a 09 09 64 6f 6e 65 0a  ide/ ';'...done.
1870: 0a 09 09 23 23 20 43 72 65 61 74 65 20 4d 61 6b  ...## Create Mak
1880: 65 66 69 6c 65 0a 09 09 63 61 74 20 3c 3c 20 5c  efile...cat << \
1890: 5f 45 4f 46 5f 20 3e 20 74 68 69 72 64 5f 70 61  _EOF_ > third_pa
18a0: 72 74 79 2f 70 63 73 63 2d 6c 69 74 65 2f 63 6c  rty/pcsc-lite/cl
18b0: 69 65 6e 74 2d 73 69 64 65 2f 4d 61 6b 65 66 69  ient-side/Makefi
18c0: 6c 65 20 7c 7c 20 65 78 69 74 20 31 0a 43 46 4c  le || exit 1.CFL
18d0: 41 47 53 20 20 20 2b 3d 20 2d 57 61 6c 6c 20 2d  AGS   += -Wall -
18e0: 73 74 64 3d 67 6e 75 2b 2b 31 31 0a 43 58 58 46  std=gnu++11.CXXF
18f0: 4c 41 47 53 20 2b 3d 20 2d 57 61 6c 6c 20 2d 73  LAGS += -Wall -s
1900: 74 64 3d 67 6e 75 2b 2b 31 31 0a 43 50 50 46 4c  td=gnu++11.CPPFL
1910: 41 47 53 20 2b 3d 20 2d 49 2e 2e 2f 73 72 63 2f  AGS += -I../src/
1920: 73 72 63 2f 50 43 53 43 0a 0a 4f 42 4a 53 20 3d  src/PCSC..OBJS =
1930: 20 70 63 73 63 5f 6e 61 63 6c 2e 6f 20 70 63 73   pcsc_nacl.o pcs
1940: 63 5f 6e 61 63 6c 5f 67 6c 6f 62 61 6c 2e 6f 20  c_nacl_global.o 
1950: 73 63 61 72 64 5f 73 74 72 75 63 74 73 5f 73 65  scard_structs_se
1960: 72 69 61 6c 69 7a 61 74 69 6f 6e 2e 6f 20 70 70  rialization.o pp
1970: 5f 76 61 72 5f 75 74 69 6c 73 2e 6f 20 6c 6f 67  _var_utils.o log
1980: 67 69 6e 67 2e 6f 20 64 6f 6d 5f 72 65 71 75 65  ging.o dom_reque
1990: 73 74 73 5f 6d 61 6e 61 67 65 72 2e 6f 20 70 63  sts_manager.o pc
19a0: 73 63 5f 6e 61 63 6c 5f 69 6e 69 74 2e 6f 0a 0a  sc_nacl_init.o..
19b0: 61 6c 6c 3a 20 6c 69 62 70 63 73 63 2e 61 0a 0a  all: libpcsc.a..
19c0: 6c 69 62 70 63 73 63 2e 61 3a 20 24 28 4f 42 4a  libpcsc.a: $(OBJ
19d0: 53 29 0a 09 72 6d 20 2d 66 20 6c 69 62 70 63 73  S)..rm -f libpcs
19e0: 63 2e 61 0a 09 24 28 41 52 29 20 72 63 20 6c 69  c.a..$(AR) rc li
19f0: 62 70 63 73 63 2e 61 20 24 28 4f 42 4a 53 29 0a  bpcsc.a $(OBJS).
1a00: 09 2d 24 28 52 41 4e 4c 49 42 29 20 6c 69 62 70  .-$(RANLIB) libp
1a10: 63 73 63 2e 61 0a 0a 70 63 73 63 5f 6e 61 63 6c  csc.a..pcsc_nacl
1a20: 5f 69 6e 69 74 2e 6f 3a 20 70 63 73 63 5f 6e 61  _init.o: pcsc_na
1a30: 63 6c 5f 69 6e 69 74 2e 63 63 20 70 63 73 63 5f  cl_init.cc pcsc_
1a40: 6e 61 63 6c 5f 67 6c 6f 62 61 6c 2e 68 20 64 6f  nacl_global.h do
1a50: 6d 5f 72 65 71 75 65 73 74 73 5f 6d 61 6e 61 67  m_requests_manag
1a60: 65 72 2e 68 20 70 63 73 63 5f 6e 61 63 6c 2e 68  er.h pcsc_nacl.h
1a70: 0a 0a 70 63 73 63 5f 6e 61 63 6c 2e 6f 3a 20 70  ..pcsc_nacl.o: p
1a80: 63 73 63 5f 6e 61 63 6c 2e 63 63 20 70 63 73 63  csc_nacl.cc pcsc
1a90: 5f 6e 61 63 6c 2e 68 20 6c 6f 67 67 69 6e 67 2e  _nacl.h logging.
1aa0: 68 20 70 70 5f 76 61 72 5f 75 74 69 6c 73 2e 68  h pp_var_utils.h
1ab0: 20 73 63 61 72 64 5f 73 74 72 75 63 74 73 5f 73   scard_structs_s
1ac0: 65 72 69 61 6c 69 7a 61 74 69 6f 6e 2e 68 0a 70  erialization.h.p
1ad0: 63 73 63 5f 6e 61 63 6c 2e 68 3a 20 64 6f 6d 5f  csc_nacl.h: dom_
1ae0: 72 65 71 75 65 73 74 73 5f 6d 61 6e 61 67 65 72  requests_manager
1af0: 2e 68 20 74 68 72 65 61 64 5f 73 61 66 65 5f 73  .h thread_safe_s
1b00: 74 72 69 6e 67 5f 70 6f 6f 6c 2e 68 0a 0a 70 63  tring_pool.h..pc
1b10: 73 63 5f 6e 61 63 6c 5f 67 6c 6f 62 61 6c 2e 6f  sc_nacl_global.o
1b20: 3a 20 70 63 73 63 5f 6e 61 63 6c 5f 67 6c 6f 62  : pcsc_nacl_glob
1b30: 61 6c 2e 63 63 20 70 63 73 63 5f 6e 61 63 6c 5f  al.cc pcsc_nacl_
1b40: 67 6c 6f 62 61 6c 2e 68 20 6c 6f 67 67 69 6e 67  global.h logging
1b50: 2e 68 0a 70 63 73 63 5f 6e 61 63 6c 5f 67 6c 6f  .h.pcsc_nacl_glo
1b60: 62 61 6c 2e 68 3a 20 70 63 73 63 5f 6e 61 63 6c  bal.h: pcsc_nacl
1b70: 2e 68 0a 0a 70 70 5f 76 61 72 5f 75 74 69 6c 73  .h..pp_var_utils
1b80: 2e 6f 3a 20 70 70 5f 76 61 72 5f 75 74 69 6c 73  .o: pp_var_utils
1b90: 2e 63 63 20 70 70 5f 76 61 72 5f 75 74 69 6c 73  .cc pp_var_utils
1ba0: 2e 68 20 6c 6f 67 67 69 6e 67 2e 68 0a 70 70 5f  .h logging.h.pp_
1bb0: 76 61 72 5f 75 74 69 6c 73 2e 68 3a 20 6c 6f 67  var_utils.h: log
1bc0: 67 69 6e 67 2e 68 0a 0a 73 63 61 72 64 5f 73 74  ging.h..scard_st
1bd0: 72 75 63 74 73 5f 73 65 72 69 61 6c 69 7a 61 74  ructs_serializat
1be0: 69 6f 6e 2e 6f 3a 20 73 63 61 72 64 5f 73 74 72  ion.o: scard_str
1bf0: 75 63 74 73 5f 73 65 72 69 61 6c 69 7a 61 74 69  ucts_serializati
1c00: 6f 6e 2e 63 63 20 73 63 61 72 64 5f 73 74 72 75  on.cc scard_stru
1c10: 63 74 73 5f 73 65 72 69 61 6c 69 7a 61 74 69 6f  cts_serializatio
1c20: 6e 2e 68 20 70 70 5f 76 61 72 5f 75 74 69 6c 73  n.h pp_var_utils
1c30: 2e 68 0a 73 63 61 72 64 5f 73 74 72 75 63 74 73  .h.scard_structs
1c40: 5f 73 65 72 69 61 6c 69 7a 61 74 69 6f 6e 2e 68  _serialization.h
1c50: 3a 20 70 70 5f 76 61 72 5f 75 74 69 6c 73 2e 68  : pp_var_utils.h
1c60: 0a 0a 64 6f 6d 5f 72 65 71 75 65 73 74 73 5f 6d  ..dom_requests_m
1c70: 61 6e 61 67 65 72 2e 6f 3a 20 64 6f 6d 5f 72 65  anager.o: dom_re
1c80: 71 75 65 73 74 73 5f 6d 61 6e 61 67 65 72 2e 63  quests_manager.c
1c90: 63 20 64 6f 6d 5f 72 65 71 75 65 73 74 73 5f 6d  c dom_requests_m
1ca0: 61 6e 61 67 65 72 2e 68 20 6c 6f 67 67 69 6e 67  anager.h logging
1cb0: 2e 68 20 70 70 5f 76 61 72 5f 75 74 69 6c 73 2e  .h pp_var_utils.
1cc0: 68 0a 0a 6c 6f 67 67 69 6e 67 2e 6f 3a 20 6c 6f  h..logging.o: lo
1cd0: 67 67 69 6e 67 2e 63 63 20 6c 6f 67 67 69 6e 67  gging.cc logging
1ce0: 2e 68 0a 0a 63 6c 65 61 6e 3a 0a 09 72 6d 20 2d  .h..clean:..rm -
1cf0: 66 20 24 28 4f 42 4a 53 29 0a 09 72 6d 20 2d 66  f $(OBJS)..rm -f
1d00: 20 6c 69 62 70 63 73 63 2e 61 0a 0a 64 69 73 74   libpcsc.a..dist
1d10: 63 6c 65 61 6e 3a 20 63 6c 65 61 6e 0a 0a 2e 50  clean: clean...P
1d20: 48 4f 4e 59 3a 20 61 6c 6c 20 63 6c 65 61 6e 20  HONY: all clean 
1d30: 64 69 73 74 63 6c 65 61 6e 0a 5f 45 4f 46 5f 0a  distclean._EOF_.
1d40: 0a 09 09 23 23 20 43 72 65 61 74 65 20 69 6e 69  ...## Create ini
1d50: 74 69 61 6c 69 7a 61 74 69 6f 6e 20 70 72 6f 63  tialization proc
1d60: 65 64 75 72 65 2c 20 73 69 6e 63 65 20 69 74 20  edure, since it 
1d70: 6c 61 63 6b 73 20 6f 6e 65 0a 09 09 63 61 74 20  lacks one...cat 
1d80: 3c 3c 20 5c 5f 45 4f 46 5f 20 3e 20 74 68 69 72  << \_EOF_ > thir
1d90: 64 5f 70 61 72 74 79 2f 70 63 73 63 2d 6c 69 74  d_party/pcsc-lit
1da0: 65 2f 63 6c 69 65 6e 74 2d 73 69 64 65 2f 70 63  e/client-side/pc
1db0: 73 63 5f 6e 61 63 6c 5f 69 6e 69 74 2e 63 63 0a  sc_nacl_init.cc.
1dc0: 23 69 6e 63 6c 75 64 65 20 3c 70 70 61 70 69 2f  #include <ppapi/
1dd0: 63 70 70 2f 63 6f 72 65 2e 68 3e 0a 23 69 6e 63  cpp/core.h>.#inc
1de0: 6c 75 64 65 20 3c 70 70 61 70 69 2f 63 70 70 2f  lude <ppapi/cpp/
1df0: 69 6e 73 74 61 6e 63 65 2e 68 3e 0a 0a 23 69 6e  instance.h>..#in
1e00: 63 6c 75 64 65 20 3c 73 74 64 69 6f 2e 68 3e 0a  clude <stdio.h>.
1e10: 0a 23 69 6e 63 6c 75 64 65 20 22 70 63 73 63 5f  .#include "pcsc_
1e20: 6e 61 63 6c 5f 67 6c 6f 62 61 6c 2e 68 22 0a 23  nacl_global.h".#
1e30: 69 6e 63 6c 75 64 65 20 22 64 6f 6d 5f 72 65 71  include "dom_req
1e40: 75 65 73 74 73 5f 6d 61 6e 61 67 65 72 2e 68 22  uests_manager.h"
1e50: 0a 23 69 6e 63 6c 75 64 65 20 22 70 63 73 63 5f  .#include "pcsc_
1e60: 6e 61 63 6c 2e 68 22 0a 0a 76 6f 69 64 20 70 63  nacl.h"..void pc
1e70: 73 63 4e 61 43 6c 49 6e 69 74 28 70 70 3a 3a 49  scNaClInit(pp::I
1e80: 6e 73 74 61 6e 63 65 20 2a 69 6e 73 74 61 6e 63  nstance *instanc
1e90: 65 2c 20 70 70 3a 3a 43 6f 72 65 20 2a 63 6f 72  e, pp::Core *cor
1ea0: 65 29 20 7b 0a 09 44 6f 6d 52 65 71 75 65 73 74  e) {..DomRequest
1eb0: 73 4d 61 6e 61 67 65 72 3a 3a 50 70 44 65 6c 65  sManager::PpDele
1ec0: 67 61 74 65 49 6d 70 6c 20 2a 64 72 6d 44 65 6c  gateImpl *drmDel
1ed0: 65 67 61 74 65 49 6d 70 6c 3b 0a 09 50 63 73 63  egateImpl;..Pcsc
1ee0: 4e 61 63 6c 20 2a 70 63 73 63 5f 6e 61 63 6c 3b  Nacl *pcsc_nacl;
1ef0: 0a 0a 09 66 70 72 69 6e 74 66 28 73 74 64 65 72  ...fprintf(stder
1f00: 72 2c 20 22 43 61 6c 6c 65 64 20 70 63 73 63 4e  r, "Called pcscN
1f10: 61 43 6c 49 6e 69 74 28 29 5c 6e 22 29 3b 0a 0a  aClInit()\n");..
1f20: 09 64 72 6d 44 65 6c 65 67 61 74 65 49 6d 70 6c  .drmDelegateImpl
1f30: 20 3d 20 6e 65 77 20 44 6f 6d 52 65 71 75 65 73   = new DomReques
1f40: 74 73 4d 61 6e 61 67 65 72 3a 3a 50 70 44 65 6c  tsManager::PpDel
1f50: 65 67 61 74 65 49 6d 70 6c 28 69 6e 73 74 61 6e  egateImpl(instan
1f60: 63 65 2c 20 63 6f 72 65 29 3b 0a 0a 09 70 63 73  ce, core);...pcs
1f70: 63 5f 6e 61 63 6c 20 3d 20 6e 65 77 20 50 63 73  c_nacl = new Pcs
1f80: 63 4e 61 63 6c 28 6e 65 77 20 44 6f 6d 52 65 71  cNacl(new DomReq
1f90: 75 65 73 74 73 4d 61 6e 61 67 65 72 28 22 70 63  uestsManager("pc
1fa0: 73 63 2d 6e 61 63 6c 22 2c 20 64 72 6d 44 65 6c  sc-nacl", drmDel
1fb0: 65 67 61 74 65 49 6d 70 6c 29 2c 20 22 6b 68 70  egateImpl), "khp
1fc0: 66 65 61 61 6e 6a 6e 67 6d 63 6e 70 6c 62 64 6c  feaanjngmcnplbdl
1fd0: 70 65 67 69 69 66 67 70 66 67 64 63 6f 22 2c 20  pegiifgpfgdco", 
1fe0: 22 43 41 43 4b 65 79 22 29 3b 0a 0a 09 66 70 72  "CACKey");...fpr
1ff0: 69 6e 74 66 28 73 74 64 65 72 72 2c 20 22 4e 65  intf(stderr, "Ne
2000: 77 20 50 63 73 63 4e 61 63 6c 20 6f 62 6a 65 63  w PcscNacl objec
2010: 74 20 3d 20 25 70 5c 6e 22 2c 20 70 63 73 63 5f  t = %p\n", pcsc_
2020: 6e 61 63 6c 29 3b 0a 0a 09 69 66 20 28 21 70 63  nacl);...if (!pc
2030: 73 63 5f 6e 61 63 6c 2d 3e 49 6e 69 74 69 61 6c  sc_nacl->Initial
2040: 69 7a 65 28 29 29 20 7b 0a 09 09 66 70 72 69 6e  ize()) {...fprin
2050: 74 66 28 73 74 64 65 72 72 2c 20 22 50 63 73 63  tf(stderr, "Pcsc
2060: 4e 61 63 6c 2d 3e 49 6e 69 74 69 61 6c 69 7a 65  Nacl->Initialize
2070: 28 29 20 66 61 69 6c 65 64 20 21 22 29 3b 0a 0a  () failed !");..
2080: 09 09 72 65 74 75 72 6e 3b 0a 09 7d 0a 0a 09 53  ..return;..}...S
2090: 65 74 50 63 73 63 4e 61 63 6c 47 6c 6f 62 61 6c  etPcscNaclGlobal
20a0: 49 6e 73 74 61 6e 63 65 28 70 63 73 63 5f 6e 61  Instance(pcsc_na
20b0: 63 6c 29 3b 0a 0a 09 66 70 72 69 6e 74 66 28 73  cl);...fprintf(s
20c0: 74 64 65 72 72 2c 20 22 47 6c 6f 62 61 6c 20 69  tderr, "Global i
20d0: 6e 73 74 61 6e 63 65 20 73 65 74 20 74 6f 20 25  nstance set to %
20e0: 70 5c 6e 22 2c 20 70 63 73 63 5f 6e 61 63 6c 29  p\n", pcsc_nacl)
20f0: 3b 0a 0a 09 66 70 72 69 6e 74 66 28 73 74 64 65  ;...fprintf(stde
2100: 72 72 2c 20 22 52 65 74 75 72 6e 69 6e 67 2e 5c  rr, "Returning.\
2110: 6e 22 29 3b 0a 0a 09 72 65 74 75 72 6e 3b 0a 7d  n");...return;.}
2120: 0a 5f 45 4f 46 5f 0a 0a 09 09 23 23 20 4d 61 6b  ._EOF_....## Mak
2130: 65 20 69 74 0a 09 09 6d 61 6b 65 20 2d 43 20 74  e it...make -C t
2140: 68 69 72 64 5f 70 61 72 74 79 2f 70 63 73 63 2d  hird_party/pcsc-
2150: 6c 69 74 65 2f 63 6c 69 65 6e 74 2d 73 69 64 65  lite/client-side
2160: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 23 20   || exit 1....# 
2170: 49 6e 73 74 61 6c 6c 20 74 68 65 20 62 75 69 6c  Install the buil
2180: 74 20 6c 69 62 70 63 73 63 0a 09 09 6d 6b 64 69  t libpcsc...mkdi
2190: 72 20 2d 70 20 22 24 7b 69 6e 73 74 64 69 72 7d  r -p "${instdir}
21a0: 2f 6c 69 62 22 20 7c 7c 20 65 78 69 74 20 31 0a  /lib" || exit 1.
21b0: 09 09 63 70 20 74 68 69 72 64 5f 70 61 72 74 79  ..cp third_party
21c0: 2f 70 63 73 63 2d 6c 69 74 65 2f 63 6c 69 65 6e  /pcsc-lite/clien
21d0: 74 2d 73 69 64 65 2f 6c 69 62 70 63 73 63 2e 61  t-side/libpcsc.a
21e0: 20 22 24 7b 69 6e 73 74 64 69 72 7d 2f 6c 69 62   "${instdir}/lib
21f0: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 29 20 7c  " || exit 1..) |
2200: 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09 72 6d 20  | return 1...rm 
2210: 2d 72 66 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22  -rf "${workdir}"
2220: 0a 0a 09 72 65 74 75 72 6e 20 30 0a 7d 0a 0a 23  ...return 0.}..#
2230: 20 42 75 69 6c 64 20 6f 75 72 20 43 41 43 4b 65   Build our CACKe
2240: 79 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64  y.function build
2250: 43 41 43 4b 65 79 28 29 20 7b 0a 09 6c 6f 63 61  CACKey() {..loca
2260: 6c 20 70 6c 61 74 66 6f 72 6d 0a 09 6c 6f 63 61  l platform..loca
2270: 6c 20 66 69 6c 65 20 63 6f 70 69 65 64 0a 09 6c  l file copied..l
2280: 6f 63 61 6c 20 74 61 72 67 65 74 73 0a 0a 09 62  ocal targets...b
2290: 75 69 6c 64 5a 6c 69 62 20 7c 7c 20 72 65 74 75  uildZlib || retu
22a0: 72 6e 20 31 0a 09 62 75 69 6c 64 50 43 53 43 20  rn 1..buildPCSC 
22b0: 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09 28 0a  || return 1...(.
22c0: 09 09 63 64 20 2e 2e 2f 2e 2e 20 7c 7c 20 65 78  ..cd ../.. || ex
22d0: 69 74 20 31 0a 0a 09 09 6d 61 6b 65 20 64 69 73  it 1....make dis
22e0: 74 63 6c 65 61 6e 0a 0a 09 09 2e 2f 63 6f 6e 66  tclean...../conf
22f0: 69 67 75 72 65 20 2d 2d 68 6f 73 74 3d 6e 61 63  igure --host=nac
2300: 6c 20 2d 2d 77 69 74 68 2d 70 63 73 63 2d 68 65  l --with-pcsc-he
2310: 61 64 65 72 73 3d 22 24 7b 69 6e 73 74 64 69 72  aders="${instdir
2320: 7d 2f 69 6e 63 6c 75 64 65 2f 50 43 53 43 22 20  }/include/PCSC" 
2330: 2d 2d 77 69 74 68 2d 70 63 73 63 2d 6c 69 62 73  --with-pcsc-libs
2340: 3d 22 2d 6c 70 63 73 63 22 20 63 61 63 6b 65 79  ="-lpcsc" cackey
2350: 5f 63 76 5f 70 63 73 63 5f 77 6f 72 6b 73 3d 6f  _cv_pcsc_works=o
2360: 6b 61 79 20 7c 7c 20 65 78 69 74 20 31 0a 09 09  kay || exit 1...
2370: 6d 61 6b 65 20 7c 7c 20 65 78 69 74 20 31 0a 09  make || exit 1..
2380: 29 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09  ) || return 1...
2390: 6d 6b 64 69 72 20 2d 70 20 22 24 7b 69 6e 73 74  mkdir -p "${inst
23a0: 64 69 72 7d 2f 6c 69 62 22 0a 09 63 70 20 2e 2e  dir}/lib"..cp ..
23b0: 2f 2e 2e 2f 6c 69 62 63 61 63 6b 65 79 2e 61 20  /../libcackey.a 
23c0: 2e 2e 2f 2e 2e 2f 6c 69 62 63 61 63 6b 65 79 5f  ../../libcackey_
23d0: 67 2e 61 20 22 24 7b 69 6e 73 74 64 69 72 7d 2f  g.a "${instdir}/
23e0: 6c 69 62 22 20 7c 7c 20 72 65 74 75 72 6e 20 31  lib" || return 1
23f0: 0a 0a 09 72 65 74 75 72 6e 20 30 0a 7d 0a 0a 69  ...return 0.}..i
2400: 6e 73 74 64 69 72 3d 22 77 6f 72 6b 64 69 72 2d  nstdir="workdir-
2410: 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f  ${RANDOM}${RANDO
2420: 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e  M}${RANDOM}${RAN
2430: 44 4f 4d 7d 2e 69 6e 73 74 22 0a 72 6d 20 2d 72  DOM}.inst".rm -r
2440: 66 20 22 24 7b 69 6e 73 74 64 69 72 7d 22 0a 6d  f "${instdir}".m
2450: 6b 64 69 72 20 22 24 7b 69 6e 73 74 64 69 72 7d  kdir "${instdir}
2460: 22 20 7c 7c 20 65 78 69 74 20 31 0a 69 6e 73 74  " || exit 1.inst
2470: 64 69 72 3d 22 24 28 63 64 20 22 24 7b 69 6e 73  dir="$(cd "${ins
2480: 74 64 69 72 7d 22 20 26 26 20 70 77 64 29 22 20  tdir}" && pwd)" 
2490: 7c 7c 20 65 78 69 74 20 31 0a 0a 43 46 4c 41 47  || exit 1..CFLAG
24a0: 53 3d 22 24 7b 43 46 4c 41 47 53 7d 20 2d 49 24  S="${CFLAGS} -I$
24b0: 7b 69 6e 73 74 64 69 72 7d 2f 69 6e 63 6c 75 64  {instdir}/includ
24c0: 65 22 0a 43 50 50 46 4c 41 47 53 3d 22 24 7b 43  e".CPPFLAGS="${C
24d0: 50 50 46 4c 41 47 53 7d 20 2d 49 24 7b 69 6e 73  PPFLAGS} -I${ins
24e0: 74 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 43  tdir}/include".C
24f0: 58 58 46 4c 41 47 53 3d 22 24 7b 43 58 58 46 4c  XXFLAGS="${CXXFL
2500: 41 47 53 7d 20 2d 49 24 7b 69 6e 73 74 64 69 72  AGS} -I${instdir
2510: 7d 2f 69 6e 63 6c 75 64 65 22 0a 4c 44 46 4c 41  }/include".LDFLA
2520: 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d  GS="${LDFLAGS} -
2530: 4c 24 7b 69 6e 73 74 64 69 72 7d 2f 6c 69 62 22  L${instdir}/lib"
2540: 0a 65 78 70 6f 72 74 20 43 46 4c 41 47 53 20 43  .export CFLAGS C
2550: 50 50 46 4c 41 47 53 20 43 58 58 46 4c 41 47 53  PPFLAGS CXXFLAGS
2560: 20 4c 44 46 4c 41 47 53 0a 0a 62 75 69 6c 64 43   LDFLAGS..buildC
2570: 41 43 4b 65 79 20 7c 7c 20 65 78 69 74 20 31 0a  ACKey || exit 1.
2580: 0a 65 78 69 74 20 30 0a                          .exit 0.